# corva_data_assets
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import corva_data_assets
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import corva_data_assets
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import corva_data_assets
from corva_data_assets.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = corva_data_assets.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: APIKeyHeader
configuration.api_key['APIKeyHeader'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['APIKeyHeader'] = 'Bearer'

# Configure Bearer authorization: HTTPBearer
configuration = corva_data_assets.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with corva_data_assets.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = corva_data_assets.CorvaAssetsApi(api_client)
    provider = 'provider_example' # str | 
    dataset = 'dataset_example' # str | 
    limit = 56 # int | Maximum number of results to return
    query = 'query_example' # str | Search conditions
    sort = '{\"timestamp\":1}' # str | Sort conditions
    skip = 0 # int | Number of records to skip (default: 0) (optional) (default to 0)
    fields = 'fields_example' # str | Comma separated list of fields to return (optional)

    try:
        # Find Data
        api_response = api_instance.find_data_provider_dataset(provider, dataset, limit, query, sort, skip=skip, fields=fields)
        print("The response of CorvaAssetsApi->find_data_provider_dataset:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling CorvaAssetsApi->find_data_provider_dataset: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CorvaAssetsApi* | [**find_data_provider_dataset**](docs/CorvaAssetsApi.md#find_data_provider_dataset) | **GET** /api/v1/data/{provider}/{dataset}/ | Find Data


## Documentation For Models

 - [CorvaAsset](docs/CorvaAsset.md)
 - [CorvaAssetProgram](docs/CorvaAssetProgram.md)
 - [CorvaAssetRig](docs/CorvaAssetRig.md)
 - [CorvaAssetStats](docs/CorvaAssetStats.md)
 - [CorvaAssetTopHole](docs/CorvaAssetTopHole.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="HTTPBearer"></a>
### HTTPBearer

- **Type**: Bearer authentication

<a id="APIKeyHeader"></a>
### APIKeyHeader

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author




